Package org.springframework.web.servlet.handler

# Class AbstractHandlerExceptionResolver

java.lang.Object
org.springframework.web.servlet.handler.AbstractHandlerExceptionResolver

All Implemented Interfaces:
  `org.springframework.core.Ordered`, `HandlerExceptionResolver`

Direct Known Subclasses:
  `AbstractHandlerMethodExceptionResolver`, `DefaultHandlerExceptionResolver`, `ResponseStatusExceptionResolver`, `SimpleMappingExceptionResolver`

public abstract class AbstractHandlerExceptionResolver extends Object implements HandlerExceptionResolver, org.springframework.core.Ordered
Abstract base class for `HandlerExceptionResolver` implementations.

Supports mapped handlers and handler classes that the resolver should be applied to and implements the `Ordered` interface.

Since:
  3.0
Author:
  Arjen Poutsma, Juergen Hoeller, Sam Brannen

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final org.apache.commons.logging.Log`
`logger`
Logger available to subclasses.

### Fields inherited from interface org.springframework.core.Ordered

`HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

## Constructor Summary

Constructors
Constructor
Description
`AbstractHandlerExceptionResolver()`

## Method Summary

Modifier and Type
Method
Description
`void`
`addMappedHandlerClass(Class<?> mappedHandlerClass)`
Alternative to `setMappedHandlerClasses(Class[])`.
`protected String`
`buildLogMessage(Exception ex, HttpServletRequest request)`
Build a log message for the given exception, occurred during processing the given request.
`protected abstract ModelAndView`
`doResolveException(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex)`
Actually resolve the given exception that got thrown during handler execution, returning a `ModelAndView` that represents a specific error page if appropriate.
`protected Class<?>[]`
`getMappedHandlerClasses()`
Return the `configured` mapped handler classes.
`int`
`getOrder()`
`protected boolean`
`hasHandlerMappings()`
Whether there are any handler mappings registered via `setMappedHandlers(Set)`, `setMappedHandlerClasses(Class[])`, or `setMappedHandlerPredicate(Predicate)`.
`protected void`
`logException(Exception ex, HttpServletRequest request)`
Log the given exception at warn level, provided that warn logging has been activated through the `"warnLogCategory"` property.
`protected void`
`prepareResponse(Exception ex, HttpServletResponse response)`
Prepare the response for the exceptional case.
`protected void`
`preventCaching(HttpServletResponse response)`
Prevents the response from being cached, through setting corresponding HTTP `Cache-Control: no-store` header.
`ModelAndView`
`resolveException(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex)`
Check whether this resolver is supposed to apply (i.e.
`void`
`setMappedHandlerClasses(Class<?>... mappedHandlerClasses)`
Specify the set of classes that this exception resolver should apply to.
`void`
`setMappedHandlerPredicate(Predicate<Object> predicate)`
Use a `Predicate` to determine which handlers this exception resolver applies to, including when the request was not mapped in which case the handler is `null`.
`void`
`setMappedHandlers(Set<?> mappedHandlers)`
Specify the set of handlers that this exception resolver should apply to.
`void`
`setOrder(int order)`
`void`
`setPreventResponseCaching(boolean preventResponseCaching)`
Specify whether to prevent HTTP response caching for any view resolved by this exception resolver.
`void`
`setWarnLogCategory(String loggerName)`
Set the log category for warn logging.
`protected boolean`
`shouldApplyTo(HttpServletRequest request, Object handler)`
Check whether this resolver is supposed to apply to the given handler.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### logger

protected final org.apache.commons.logging.Log logger
Logger available to subclasses.

## Constructor Details

### AbstractHandlerExceptionResolver

public AbstractHandlerExceptionResolver()

## Method Details

### setOrder

public void setOrder(int order)

### getOrder

public int getOrder()

Specified by:
  `getOrder` in interface `org.springframework.core.Ordered`

### setMappedHandlerPredicate

public void setMappedHandlerPredicate(Predicate<Object> predicate)
Use a `Predicate` to determine which handlers this exception resolver applies to, including when the request was not mapped in which case the handler is `null`.

If no handler predicate, nor handlers, nor handler classes are set, the exception resolver applies to all handlers.

Since:
  6.1.2

### setMappedHandlers

public void setMappedHandlers(Set<?> mappedHandlers)
Specify the set of handlers that this exception resolver should apply to.

If no handler predicate, nor handlers, nor handler classes are set, the exception resolver applies to all handlers.

See Also:
  - `setMappedHandlerPredicate(Predicate)`

### setMappedHandlerClasses

public void setMappedHandlerClasses(Class<?>... mappedHandlerClasses)
Specify the set of classes that this exception resolver should apply to. The resolver will only apply to handlers of the specified types; the specified types may be interfaces or superclasses of handlers as well.

If no handler predicate, nor handlers, nor handler classes are set, the exception resolver applies to all handlers.

See Also:
  - `setMappedHandlerPredicate(Predicate)`

### addMappedHandlerClass

public void addMappedHandlerClass(Class<?> mappedHandlerClass)
Alternative to `setMappedHandlerClasses(Class[])`.

Since:
  6.1

### getMappedHandlerClasses

@Nullable protected Class<?>[] getMappedHandlerClasses()
Return the `configured` mapped handler classes.

### setWarnLogCategory

public void setWarnLogCategory(String loggerName)
Set the log category for warn logging. The name will be passed to the underlying logger implementation through Commons Logging, getting interpreted as a log category according to the logger's configuration. If `null` or empty String is passed, warn logging is turned off.

By default there is no warn logging although subclasses like `DefaultHandlerExceptionResolver` can change that default. Specify this setting to activate warn logging into a specific category. Alternatively, override the `logException(java.lang.Exception, jakarta.servlet.http.HttpServletRequest)` method for custom logging.

See Also:
  - `LogFactory.getLog(String)`
  - `Logger.getLogger(String)`

### setPreventResponseCaching

public void setPreventResponseCaching(boolean preventResponseCaching)
Specify whether to prevent HTTP response caching for any view resolved by this exception resolver.

Default is `false`. Switch this to `true` in order to automatically generate HTTP response headers that suppress response caching.

### resolveException

@Nullable public ModelAndView resolveException(HttpServletRequest request, HttpServletResponse response, @Nullable Object handler, Exception ex)
Check whether this resolver is supposed to apply (i.e. if the supplied handler matches any of the configured handlers or handler classes), and then delegate to the `doResolveException(jakarta.servlet.http.HttpServletRequest, jakarta.servlet.http.HttpServletResponse, java.lang.Object, java.lang.Exception)` template method.

Specified by:
  `resolveException` in interface `HandlerExceptionResolver`
Parameters:
  `request` - current HTTP request
  `response` - current HTTP response
  `handler` - the executed handler, or `null` if none chosen at the time of the exception (for example, if multipart resolution failed)
  `ex` - the exception that got thrown during handler execution
Returns:
  a corresponding `ModelAndView` to forward to, or `null` for default processing in the resolution chain

### shouldApplyTo

protected boolean shouldApplyTo(HttpServletRequest request, @Nullable Object handler)
Check whether this resolver is supposed to apply to the given handler.

The default implementation checks against the configured handlerPredicate handlers and handler classes, if any.

Parameters:
  `request` - current HTTP request
  `handler` - the executed handler, or `null` if none chosen at the time of the exception (for example, if multipart resolution failed)
Returns:
  whether this resolved should proceed with resolving the exception for the given request and handler
See Also:
  - `setMappedHandlers(java.util.Set<?>)`
  - `setMappedHandlerClasses(java.lang.Class<?>...)`

### hasHandlerMappings

protected boolean hasHandlerMappings()
Whether there are any handler mappings registered via `setMappedHandlers(Set)`, `setMappedHandlerClasses(Class[])`, or `setMappedHandlerPredicate(Predicate)`.

Since:
  5.3

### logException

protected void logException(Exception ex, HttpServletRequest request)
Log the given exception at warn level, provided that warn logging has been activated through the `"warnLogCategory"` property.

Calls `buildLogMessage(java.lang.Exception, jakarta.servlet.http.HttpServletRequest)` in order to determine the concrete message to log.

Parameters:
  `ex` - the exception that got thrown during handler execution
  `request` - current HTTP request (useful for obtaining metadata)
See Also:
  - `setWarnLogCategory(java.lang.String)`
  - `buildLogMessage(java.lang.Exception, jakarta.servlet.http.HttpServletRequest)`
  - `Log.warn(Object, Throwable)`

### buildLogMessage

protected String buildLogMessage(Exception ex, HttpServletRequest request)
Build a log message for the given exception, occurred during processing the given request.

Parameters:
  `ex` - the exception that got thrown during handler execution
  `request` - current HTTP request (useful for obtaining metadata)
Returns:
  the log message to use

### prepareResponse

protected void prepareResponse(Exception ex, HttpServletResponse response)
Prepare the response for the exceptional case.

The default implementation prevents the response from being cached, if the `"preventResponseCaching"` property has been set to "true".

Parameters:
  `ex` - the exception that got thrown during handler execution
  `response` - current HTTP response
See Also:
  - `preventCaching(jakarta.servlet.http.HttpServletResponse)`

### preventCaching

protected void preventCaching(HttpServletResponse response)
Prevents the response from being cached, through setting corresponding HTTP `Cache-Control: no-store` header.

Parameters:
  `response` - current HTTP response

### doResolveException

@Nullable protected abstract ModelAndView doResolveException(HttpServletRequest request, HttpServletResponse response, @Nullable Object handler, Exception ex)
Actually resolve the given exception that got thrown during handler execution, returning a `ModelAndView` that represents a specific error page if appropriate.

May be overridden in subclasses, in order to apply specific exception checks. Note that this template method will be invoked after checking whether this resolver applies ("mappedHandlers" etc), so an implementation may simply proceed with its actual exception handling.

Parameters:
  `request` - current HTTP request
  `response` - current HTTP response
  `handler` - the executed handler, or `null` if none chosen at the time of the exception (for example, if multipart resolution failed)
  `ex` - the exception that got thrown during handler execution
Returns:
  a corresponding `ModelAndView` to forward to, or `null` for default processing in the resolution chain